#! /usr/bin/python
#-------------------------------------------------------------------------------
#
# Copyright 2015-2020 Cumulus Networks, inc  all rights reserved
#
#-------------------------------------------------------------------------------
#

try:
    import subprocess
    import os
    import json
except ImportError, e:
    raise ImportError (str(e) + "- required module not found")

# Get the clagId cfg created before the beginning of this life
def getClagIdConfig(Log):
    clagCfg = {}

    clagReloadScript = "/lib/clagctl-utils/clagctlRestartConfig"
    if os.path.isfile(clagReloadScript) and os.access(clagReloadScript, os.X_OK):
        try:
            debugFlag = ["--debug"] if Log.getDebug() & Log._LOG_DEBUG_RELOAD else []
            clagCfgStr = subprocess.check_output([clagReloadScript]+debugFlag)
            Log.log_debug(Log._LOG_DEBUG_RELOAD, clagReloadScript + " returned:")
            for line in clagCfgStr.splitlines():
                Log.log_debug(Log._LOG_DEBUG_RELOAD, "    " + line)
            clagCfg = json.loads(clagCfgStr)
        except subprocess.CalledProcessError as e:
            pass

    clagIntfCfg = clagCfg.get('clagIntfs', {})
    return clagIntfCfg
